Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.security.certclient.util
Class PkSsCertFactory

    java.lang.Object
      com.ibm.security.certclient.util.PkSsCertFactory

    public final class PkSsCertFactory

extends Object

Generate a self-signed certificate.

Method Summary
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, boolean useRSA, boolean useShortSubjectKId, List<String> subjectAltNames, List<String> kUsage, List<String> extKUsage, String provider)` Create a self-signed certificate with supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, boolean useRSA, boolean useShortSubjectKId, List<String> subjectAltNames, List<String> kUsage, List<String> extKUsage, String provider, KeyPair keyPair)` Create a self-signed certificate with supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, boolean useRSA, boolean useShortSubjectKId, String provider)` Create a self-signed certificate without any supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, boolean useRSA, boolean useShortSubjectKId, String provider, KeyPair keyPair)` Create a self-signed certificate without any supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, Date notBefore, boolean useRSA, boolean useShortSubjectKId, List<String> subjectAltNames, List<String> kUsage, List<String> extKUsage, String provider)` Create a self-signed certificate with supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, Date notBefore, boolean useRSA, boolean useShortSubjectKId, List<String> subjectAltNames, List<String> kUsage, List<String> extKUsage, String provider, KeyPair keyPair)` Create a self-signed certificate with supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, Date notBefore, boolean useRSA, boolean useShortSubjectKId, List<String> subjectAltNames, List<String> kUsage, List<String> extKUsage, String provider, KeyPair keyPair, boolean CA)` Create a self-signed certificate with supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, Date notBefore, boolean useRSA, boolean useShortSubjectKId, String provider)` Create a self-signed certificate without any supplied extensions
`static PkSsCertificate` | `newSsCert(int keySize, String subjectDN, int numValidDays, Date notBefore, boolean useRSA, boolean useShortSubjectKId, String provider, KeyPair keyPair)` Create a self-signed certificate without any supplied extensions
`static PkSsCertificate` | `newSsCert(String subjectDN)` Most simple way to generate a self-signed certificate.
`static PkSsCertificate` | `newSsCert(String subjectDN, Date notBefore)` Most simple way to generate a self-signed certificate.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### newSsCert

    public static PkSsCertificate newSsCert(String subjectDN)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Most simple way to generate a self-signed certificate. Uses all default values:
  - version = 3
  - keysize = 1024
  - validity period = 365 days from current date
  - signatureAlgorithm = SHA1withRSA
  - subjectKeyId version = long
  - provider = IBMJCE

  Parameters:
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(String subjectDN,
                                            Date notBefore)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Most simple way to generate a self-signed certificate. Uses all default values:
  - version = 3
  - keysize = 1024
  - validity period = 365 days from notBefore date
  - signatureAlgorithm = SHA1withRSA
  - subjectKeyId version = long
  - provider = IBMJCE

  Parameters:
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            String provider)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate without any supplied extensions

  Parameters:
    `keySize` - size of key.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificate validity. Will be measured from current date.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `provider` - name of crypto provider
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            Date notBefore,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            String provider)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate without any supplied extensions

  Parameters:
    `keySize` - size of key.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificate validity. Will be measured from notBefore date.
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `provider` - name of crypto provider
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            String provider,
                                            KeyPair keyPair)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate without any supplied extensions

  Parameters:
    `keySize` - size of key. Not used if keyPair is provided.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from current date.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm Not used if keyPair is provided.
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `provider` - name of crypto provider
    `keyPair` - keypair to use for private/public key
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            Date notBefore,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            String provider,
                                            KeyPair keyPair)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate without any supplied extensions

  Parameters:
    `keySize` - size of key. Not used if keyPair is provided.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from notBefore date.
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm Not used if keyPair is provided.
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `provider` - name of crypto provider
    `keyPair` - keypair to use for private/public key
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            List<String> subjectAltNames,
                                            List<String> kUsage,
                                            List<String> extKUsage,
                                            String provider)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate with supplied extensions

  Parameters:
    `keySize` - size of key.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from current date.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `subjectAltNames` - (optional)list of subject alternate names. Specify null to indicate that no value is being specified.
    - 0. email email address for the subject , e.g. newUser@us.ibm.com
    - 1. dnsName domain name server name. Name is not case sensitive. e.g host.domain
    - 2. uri universal resource identifier ,e.g http://www.tivoli.com, ftp://www.ibm.com/
    - 3. ipaddress ipaddress for the subject , e.g. 127.0.0.1
    `kUsage` - (optional)list of Key Usage strings. Acceptable values are- "digital_signature" "non_repudiation" "key_encipherment" "data_encipherment" "encipher_only" "decipher_only"
    `extKUsage` - (optional)list of Extended Key Usage strings. Acceptable values are- "ServerAuth_Id" "ClientAuth_Id" "CodeSigning_Id" "EmailProtection_Id" "IPSecEndSystem_Id" "IPSecTunnel_Id" "IPSecUser_Id" "TimeStamping_Id"
    `provider` - name of crypto provider
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            Date notBefore,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            List<String> subjectAltNames,
                                            List<String> kUsage,
                                            List<String> extKUsage,
                                            String provider)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate with supplied extensions

  Parameters:
    `keySize` - size of key.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from notBefore date.
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `subjectAltNames` - (optional)list of subject alternate names. Specify null to indicate that no value is being specified.
    - 0. email email address for the subject , e.g. newUser@us.ibm.com
    - 1. dnsName domain name server name. Name is not case sensitive. e.g host.domain
    - 2. uri universal resource identifier ,e.g http://www.tivoli.com, ftp://www.ibm.com/
    - 3. ipaddress ipaddress for the subject , e.g. 127.0.0.1
    `kUsage` - (optional)list of Key Usage strings. Acceptable values are- "digital_signature" "non_repudiation" "key_encipherment" "data_encipherment" "encipher_only" "decipher_only"
    `extKUsage` - (optional)list of Extended Key Usage strings. Acceptable values are- "ServerAuth_Id" "ClientAuth_Id" "CodeSigning_Id" "EmailProtection_Id" "IPSecEndSystem_Id" "IPSecTunnel_Id" "IPSecUser_Id" "TimeStamping_Id"
    `provider` - name of crypto provider
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            List<String> subjectAltNames,
                                            List<String> kUsage,
                                            List<String> extKUsage,
                                            String provider,
                                            KeyPair keyPair)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate with supplied extensions

  Parameters:
    `keySize` - size of key. Not used if keyPair is provided.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from current date.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm Not used if keyPair is provided.
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `subjectAltNames` - (optional)list of subject alternate names. Specify null to indicate that no value is being specified.
    - 0. email email address for the subject , e.g. newUser@us.ibm.com
    - 1. dnsName domain name server name. Name is not case sensitive. e.g host.domain
    - 2. uri universal resource identifier ,e.g http://www.tivoli.com, ftp://www.ibm.com/
    - 3. ipaddress ipaddress for the subject , e.g. 127.0.0.1
    `kUsage` - (optional)list of Key Usage strings. Acceptable values are- "digital_signature" "non_repudiation" "key_encipherment" "data_encipherment" "encipher_only" "decipher_only"
    `extKUsage` - (optional)list of Extended Key Usage strings. Acceptable values are- "ServerAuth_Id" "ClientAuth_Id" "CodeSigning_Id" "EmailProtection_Id" "IPSecEndSystem_Id" "IPSecTunnel_Id" "IPSecUser_Id" "TimeStamping_Id"
    `provider` - name of crypto provider
    `keyPair` - keypair to use for private/public keys if null, keypair will be generated
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            Date notBefore,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            List<String> subjectAltNames,
                                            List<String> kUsage,
                                            List<String> extKUsage,
                                            String provider,
                                            KeyPair keyPair)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate with supplied extensions

  Parameters:
    `keySize` - size of key. Not used if keyPair is provided.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from notBefore date.
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm Not used if keyPair is provided.
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `subjectAltNames` - (optional)list of subject alternate names. Specify null to indicate that no value is being specified.
    - 0. email email address for the subject , e.g. newUser@us.ibm.com
    - 1. dnsName domain name server name. Name is not case sensitive. e.g host.domain
    - 2. uri universal resource identifier ,e.g http://www.tivoli.com, ftp://www.ibm.com/
    - 3. ipaddress ipaddress for the subject , e.g. 127.0.0.1
    `kUsage` - (optional)list of Key Usage strings. Acceptable values are- "digital_signature" "non_repudiation" "key_encipherment" "data_encipherment" "encipher_only" "decipher_only"
    `extKUsage` - (optional)list of Extended Key Usage strings. Acceptable values are- "ServerAuth_Id" "ClientAuth_Id" "CodeSigning_Id" "EmailProtection_Id" "IPSecEndSystem_Id" "IPSecTunnel_Id" "IPSecUser_Id" "TimeStamping_Id"
    `provider` - name of crypto provider
    `keyPair` - keypair to use for private/public keys if null, keypair will be generated
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

### newSsCert

    public static PkSsCertificate newSsCert(int keySize,
                                            String subjectDN,
                                            int numValidDays,
                                            Date notBefore,
                                            boolean useRSA,
                                            boolean useShortSubjectKId,
                                            List<String> subjectAltNames,
                                            List<String> kUsage,
                                            List<String> extKUsage,
                                            String provider,
                                            KeyPair keyPair,
                                            boolean CA)
                                     throws com.ibm.security.certclient.base.PkRejectionException

  Create a self-signed certificate with supplied extensions

  Parameters:
    `keySize` - size of key. Not used if keyPair is provided.
    `subjectDN` - Distinguished name which will be both subject and issuer for this certificate
    `numValidDays` - period of certificaate validity. Will be measured from notBefore date.
    `notBefore` - Date that this certificate valitity begins. Must be no greater than 3 days prior to the issuing UTC time. If null, current Date will be used.
    `useRSA` - if true use RSA key with SHA1withRSA signature algorithm else DSA with SHA1withDSA algorithm Not used if keyPair is provided.
    `useShortSubjectKId` - if true use short form of Subject Key Id else use long form
    `subjectAltNames` - (optional)list of subject alternate names. Specify null to indicate that no value is being specified.
    - 0. email email address for the subject , e.g. newUser@us.ibm.com
    - 1. dnsName domain name server name. Name is not case sensitive. e.g host.domain
    - 2. uri universal resource identifier ,e.g http://www.tivoli.com, ftp://www.ibm.com/
    - 3. ipaddress ipaddress for the subject , e.g. 127.0.0.1
    `kUsage` - (optional)list of Key Usage strings. Acceptable values are- "digital_signature" "non_repudiation" "key_encipherment" "data_encipherment" "encipher_only" "decipher_only"
    `extKUsage` - (optional)list of Extended Key Usage strings. Acceptable values are- "ServerAuth_Id" "ClientAuth_Id" "CodeSigning_Id" "EmailProtection_Id" "IPSecEndSystem_Id" "IPSecTunnel_Id" "IPSecUser_Id" "TimeStamping_Id"
    `provider` - name of crypto provider
    `keyPair` - keypair to use for private/public keys if null, keypair will be generated
    `CA` - true - create this certificate as a CA with basic constraints false - create this certificate as an end-user without basic constraints
  Returns:
    a PkSsCertificate type object that implements a self-signed certificate with the provided attributes
  Throws:
    `com.ibm.security.certclient.base.PkRejectionException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD